Imports System.Drawing.Drawing2D

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents picHisto As System.Windows.Forms.PictureBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.picHisto = New System.Windows.Forms.PictureBox
        Me.SuspendLayout()
        '
        'picHisto
        '
        Me.picHisto.BackColor = System.Drawing.Color.White
        Me.picHisto.Location = New System.Drawing.Point(8, 8)
        Me.picHisto.Name = "picHisto"
        Me.picHisto.Size = New System.Drawing.Size(392, 192)
        Me.picHisto.TabIndex = 0
        Me.picHisto.TabStop = False
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(408, 205)
        Me.Controls.Add(Me.picHisto)
        Me.Name = "Form1"
        Me.Text = "Form1"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Const MIN_VALUE As Single = 0
    Private Const MAX_VALUE As Single = 100

    Private m_Colors() As Color = { _
        Color.Red, Color.Green, Color.Blue, Color.Yellow, Color.Orange, _
        Color.White, Color.Cyan, Color.Pink, Color.Tan, Color.LightGreen}
    Private m_DataValues(9) As Single

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim rnd As New Random

        ' Create data.
        For i As Integer = 0 To m_DataValues.GetUpperBound(0)
            m_DataValues(i) = rnd.Next(MIN_VALUE + 5, MAX_VALUE - 5)
        Next i
    End Sub

    Private Sub picHisto_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles picHisto.Paint
        e.Graphics.Clear(picHisto.BackColor)

        ' Flip vertically and scale to fit.
        Dim scalex As Single = picHisto.Width / (m_DataValues.GetUpperBound(0) + 2)
        Dim scaley As Single = -picHisto.Height / (MAX_VALUE + 10)
        e.Graphics.ScaleTransform( _
            scalex, scaley, MatrixOrder.Append)

        ' Translate so (0, MAX_VALUE + 10) maps to the origin.
        e.Graphics.TranslateTransform(0, picHisto.Height, MatrixOrder.Append)

        ' Draw the histogram.
        For i As Integer = 0 To m_DataValues.GetUpperBound(0)
            Dim rect As New Rectangle(i, 0, 1, m_DataValues(i))
            Dim brush_color As Color = Color.FromArgb(&HC0FFFFFF And m_Colors(i).ToArgb())
            Dim the_brush As New SolidBrush(brush_color)
            Dim pen_color As Color = Color.FromArgb(&HC0, _
                m_Colors(i).R / 2, m_Colors(i).G / 2, m_Colors(i).B / 2)
            'Dim the_pen As New Pen(pen_color, 0)
            Dim the_pen As New Pen(Color.Black, 0)

            ' Draw hidden lines.
            e.Graphics.DrawLine(the_pen, CSng(i + 0.5), 0 + 10, CSng(i + 0.5), m_DataValues(i) + 10)
            e.Graphics.DrawLine(the_pen, CSng(i + 0.5), 0 + 10, CSng(i + 1.5), 0 + 10)

            ' Face.
            Dim pts() As PointF
            pts = New PointF() { _
                New PointF(i, 0), _
                New PointF(i + 1, 0), _
                New PointF(i + 1, m_DataValues(i)), _
                New PointF(i, m_DataValues(i)) _
            }
            e.Graphics.FillPolygon(the_brush, pts)
            e.Graphics.DrawPolygon(the_pen, pts)

            ' Top.
            pts = New PointF() { _
                New PointF(i, m_DataValues(i)), _
                New PointF(i + 0.5, m_DataValues(i) + 10), _
                New PointF(i + 1.5, m_DataValues(i) + 10), _
                New PointF(i + 1, m_DataValues(i)) _
            }
            e.Graphics.FillPolygon(the_brush, pts)
            e.Graphics.DrawPolygon(the_pen, pts)

            ' Side.
            pts = New PointF() { _
                New PointF(i + 1, 0), _
                New PointF(i + 1, m_DataValues(i)), _
                New PointF(i + 1.5, m_DataValues(i) + 10), _
                New PointF(i + 1.5, 10) _
            }
            e.Graphics.FillPolygon(the_brush, pts)
            e.Graphics.DrawPolygon(the_pen, pts)

            e.Graphics.DrawRectangle(the_pen, rect)
            the_brush.Dispose()
            the_pen.Dispose()
        Next i

        e.Graphics.ResetTransform()
        e.Graphics.DrawRectangle(Pens.Black, 0, 0, picHisto.Width - 1, picHisto.Height - 1)
    End Sub

    Private Sub picHisto_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picHisto.MouseDown
        ' Determine which data value was clicked.
        Dim bar_wid As Single = picHisto.Width / (m_DataValues.GetUpperBound(0) + 2)
        Dim i As Integer = Int(e.X / bar_wid)
        MessageBox.Show(i & ": " & m_DataValues(i), "Value", MessageBoxButtons.OK, MessageBoxIcon.Information)
    End Sub
End Class
